<?php

declare(strict_types=1);

namespace App\Scolarite\Domain\Event;

use App\Administration\Domain\Model\SchoolClass\ClassId;
use App\Administration\Domain\Model\Subject\SubjectId;
use App\Scolarite\Domain\Model\Schedule\ScheduleSlotId;
use App\Shared\Domain\DomainEvent;
use DateTimeImmutable;
use Override;
use Ramsey\Uuid\UuidInterface;

final readonly class CoursSupprime implements DomainEvent
{
    public function __construct(
        public ScheduleSlotId $slotId,
        public ClassId $classId,
        public SubjectId $subjectId,
        private DateTimeImmutable $occurredOn,
    ) {
    }

    #[Override]
    public function occurredOn(): DateTimeImmutable
    {
        return $this->occurredOn;
    }

    #[Override]
    public function aggregateId(): UuidInterface
    {
        return $this->slotId->value;
    }
}
